<?php

require 'Haml.php';

function strcontains($haystack, $needle)
{
	return (strpos($haystack, $needle) !== false);
}

function startsWith($haystack, $needle)
{
    return $needle === "" || strpos($haystack, $needle) === 0;
}

function parseData($comm,$parent=false)
{
	preg_match_all('/@([a-z]+)\s(.+)\n/', $comm,$matches);
	$result = array();
	foreach ($matches[1] as $m=>$match)
	{
		if ($match=="return")
		{
			$return_parts = explode("|",$matches[2][$m]);
			$result['params'][] = array("name"=>"&rarr;","require"=>false,"type"=>$return_parts[0], "description"=>$return_parts[1]);
		}
		else if ($match=="param")
		{
			$param_parts = explode("|",$matches[2][$m]);
			$result['params'][] = array("name"=>$param_parts[0],"required"=>($param_parts[1]=="required"), "type"=>$param_parts[2], "description"=>$param_parts[3]);
		}
		else if ($match=="property")
		{
			$param_parts = explode("|",$matches[2][$m]);
			$result['properties'][] = array("name"=>$param_parts[0],"type"=>$param_parts[1],"description"=>$param_parts[2]);
		}
		else if ($match=="example")
		{
			$result['example'] .= "\n".str_replace("$$","@",$matches[2][$m]);
		}
		else
		{
			$result[$match] = $matches[2][$m];
		}
	}
	if (isset($result['class'])) { $t = $result['class']; $result['id'] = "class-"; }
	else { $t = $result['method']; $result['id'] = "method-"; }

	$result['id'] .= str_replace(" ", "-", $t);
	$result['id'] = strtolower($result['id']);
	if ($parent) $result['id'] = strtolower($parent) . "-".$result['id'];

	$result['id'] = "api-".$result['id'];
	return $result;
}

$input = $argv[1];
$contents = file_get_contents($input);
$lines = explode("\n",$contents);
$commentstart = false;
$comments = array();
$current_comment = "";
foreach ($lines as $i=>$line)
{
	if (strcontains($line,"###"))
	{
		if (!$commentstart)
		{
			$commentstart = true;
		}
		else
		{
			$commentstart = false;
			$comments[] = $current_comment;
			$current_comment = "";
		}
	}
	else
	{
		if ($commentstart)
			$current_comment .= "$line\n";
	}
}

$classes = array();
$current_class = array();

foreach ($comments as $c=>$comment)
{
	if (!startsWith($comment,"\t")) 
	{
		if (count($current_class)>0) $classes[] = $current_class;

		$current_class = parseData($comment);
	}
	else
	{
		$current_class["children"][] = parseData($comment,$current_class['class']);
	}

}

$classes[] = $current_class;

$parser = new HamlParser('./tpl', './tmp/haml');
$parser->assign('classes', $classes);
print_r($classes);
echo $parser->setFile('docgen.haml');

?>